<?php
if (!defined('ABSPATH')) {
    exit;
}

use Automattic\WooCommerce\Blocks\Payments\Integrations\AbstractPaymentMethodType;

final class WC_Gateway_Paynoloji_Blocks extends AbstractPaymentMethodType {
    private $gateway;
    protected $name = 'paynoloji';

    public function initialize() {
        $this->settings = get_option('woocommerce_paynoloji_settings', []);
        $this->gateway = new WC_Gateway_Paynoloji();
    }

    public function is_active() {
        return $this->gateway->is_available();
    }

    public function get_payment_method_script_handles() {
        wp_register_script(
            'paynoloji-blocks-integration',
            PAYNOLOGI_PLUGIN_URL . 'assets/js/blocks/checkout.js',
            [
                'wc-blocks-registry',
                'wc-settings',
                'wp-element',
                'wp-html-entities',
                'wp-i18n',
            ],
            PAYNOLOGI_PLUGIN_VERSION,
            true
        );

        if (function_exists('wp_set_script_translations')) {
            wp_set_script_translations('paynoloji-blocks-integration', PAYNOLOGI_PLUGIN_TEXTDOMAIN);
        }

        return ['paynoloji-blocks-integration'];
    }

    public function get_payment_method_data() {
        return [
            'title' => $this->gateway->title,
            'description' => $this->gateway->description,
            'supports' => $this->gateway->supports,
            'showSavedCards' => false,
            'canMakePayment' => true,
            'paymentMethodId' => $this->name,
            'adminUrl' => admin_url('admin.php?page=wc-settings&tab=checkout&section=' . $this->name),
        ];
    }
}